;************************************************************
;*******  Autor: Dave Hankovec*******************************
;*******  Popis: Maticov klvesnice  ***********************                          
;*******  Procesor: 89C2051  ********************************
;************************************************************



;Popis: pro test zasila vystupy (kody) klaves pres UART (19200Bd,8bits,No parita, 1 Stop)
;kody jsou v tabulce Kod_klaves, jsou zadane v ASCII pro prime zobrazeni v terminalu
;zapojeni portu P1 je nasledujici
;radky 1.4, 1.5, 1.6, 1.7
;sloupce 1.3, 1.2, 1.1, 1.0
;pro priklad tlacitko 1 (posle pres uart 1) je stisk 1.radek x 1.sloupec cili P1.4 x P1.3
;atd.

$MOD51

  ORG        0000H
  JMP        Init
  ORG        0030H 
;============================================================
; hlavn program
;============================================================
Init:
  	  mov sp,#35H
          mov scon,#01010000B   ;nastaven ser.linky+asovae1
          mov tmod,#00100000B   ;19200 bps,8 databit,1 stopbit,bez parity
          mov 87H,#10000000B    ;zdvojnsoben rychlosti (nastav bit SMOD)
          mov th1,#253          ;asova md 2,ser.linka md 1
	  setb TR1


	mov	R0,#'T'
	call	vysilani
	mov	R0,#'e'
	call	vysilani
	mov	R0,#'s'
	call	vysilani
	mov	R0,#'t'
	call	vysilani


	MOV     P1, #00001111B             ; nastaven vstup a vstup
	MOV     Key, #0D 


opet: 
  MOV	posuv,#11101111B             ; poten nastaven vstup
  MOV        P1, posuv             ; poten nastaven vstup

Sloupec:
  JNB        P1.3, Stisk               ; test 1.sloupce                  
  CALL       Key_plus_1                 ; Key = Key + 1
Sloupec2:
  JNB        P1.2, Stisk                ; test 2.sloupce  
  CALL       Key_plus_1                 ; Key = Key + 1
Sloupec3:
  JNB        P1.1, Stisk                ; test 3.sloupce  
  CALL       Key_plus_1                 ; Key = Key + 1
Sloupec4:
  JNB        P1.0, Stisk                ; test 4.sloupce  
  CALL       Key_plus_1                 ; Key = Key + 1
  SETB       C
  MOV        A, posuv
  RLC        A                          ; posuv portu B

  mov	     posuv,A
  MOV        P1, A
  CJNE       A, #11111111B, Sloupec           ; skok jestlie byly testovny vechny klvesy
  JMP        Konec_cyklu


Stisk:                                  
 MOV        B, P1
 CALL       Cekej_1ms
 MOV        A, P1
 CLR	    C
 SUBB       A, B
 JNZ        konec_cyklu       
 MOV        DPTR, #Kod_klavesy
 MOV        A, Key
 MOVC       A, @A+DPTR
 MOV        Klavesa, A
 MOV	    R0,klavesa
 call	    vysilani
; zde u je uloen kd klvesy a meme s nm dl pracovat
Konec_cyklu:
   MOV        Key, #0D 
   JMP        opet
;;============================================================
; obslun procedury
;============================================================  
Key_plus_1:
  MOV        A, Key
  ADD        A, #1D
  MOV        Key, A
  RET 

Cekej_1ms:
  MOV        Wait1, #250D
  MOV        Wait2, #2D
Loop2:
  DJNZ       Wait1, Loop2
  DJNZ       Wait2, Loop2
  RET



vysilani:  
          clr ti                  ;nulovn pznaku dokonenho odvysln
          mov sbuf,r0             ;vysln obsahu R0
          jnb ti,$                ;ekn na odvysln
          clr ti                  ;nulovn pznaku dokonenho odvysln
          ret


;============================================================
; obsluha peruen
;============================================================

;============================================================
; nastaven promnnch
;============================================================
Kod_klavesy:
  DB         '1', '2','3', 'A'
  DB         '4', '5','6', 'B'
  DB         '7','8','9','C'
  DB         'G', 'F', 'E', 'D'

  DSEG
  ORG        030H
Key:
  DS         1H 
Klavesa:
  DS         1H 
Wait1:
  DS         1H
Wait2:
  DS         1H 
posuv:
  DS		1H







  END
